package com.msdw.tms.aop;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.aop
 * @ClassName: Authorization
 * @Description: 安全认证
 * @Author: Maureen.Rong
 * @CreateDate: 2020/10/22 9:46
 * @UpdateDate: 2020/10/22 9:46
 * @Version: 1.0
 */

import org.springframework.stereotype.Component;

import java.lang.annotation.*;

/**
 * 在Controller的方法上使用此注解，该方法在映射时会检查用户鉴权
 */
@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
@Documented
@Component
public @interface AuthCustomize {
    //用于自定义描述等
    String value() default "";
}
