package com.msdw.tms.common.utils;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.common.utils
 * @ClassName: RedisConfig
 * @Description: redis配置类, 用于更改RedisTemplate来创建工具类
 * @Author: Maureen.Rong
 * @CreateDate: 2020/11/13 9:35
 * @UpdateDate: 2020/11/13 9:35
 * @Version: 1.0
 */
@Component
public class RedisConfig {
    @Autowired
    private RedisTemplate<String, String> redisTemplate;
    public static RedisTemplate<String, String> redis;


    @PostConstruct
    public void getRedisTemplate() {
        redis = this.redisTemplate;
    }

    /**
     * 读取缓存
     *
     * @param key
     * @return
     */
    public Object get(final String key) {
        return redis.opsForValue().get(key);
    }

}
