package com.msdw.tms.common.utils.date;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.util.Calendar;
import java.util.Date;

public class DateUtils {

    public static String handleTime(Date date) {
        Instant instant = date.toInstant();
        ZoneId zoneId = ZoneId.systemDefault();
        LocalDateTime localDateTime = instant.atZone(zoneId).toLocalDateTime();
        return localDateTime.format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")); // 当前日期和时间
    }


    public static String formatTime(LocalDateTime time) {
        String timeStr1 = time.format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
        System.out.println("当前时间为:" + timeStr1);
        return timeStr1;
    }

    /**
     * 时间类型转换
     *
     * @param time
     * @return
     */
    public static String dateForByStr(String time) {
        try {
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            Date date = sdf.parse(time);
            //获取String类型的时间
            String createdate = sdf.format(date);
            return createdate;
        } catch (ParseException e) {
            e.printStackTrace();
            return null;
        }

    }


    /**
     * 获取当前时间
     *
     * @return
     */
    /*public static String getNowTime(Integer userId) {

        String getDate = template.opsForValue().get("date:userId_" + userId);
        SimpleDateFormat tempDate = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String datetime = tempDate.format(new java.util.Date());
        //也可以用这个
        String datetimes = tempDate.format(new Date(System.currentTimeMillis()));
        return getDate;
    }*/

    /*public static String getNowTime() {
        SimpleDateFormat tempDate = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String datetime = tempDate.format(new java.util.Date());
        //也可以用这个
        String datetimes = tempDate.format(new Date(System.currentTimeMillis()));
        return datetime;
    }*/

    /**
     * 获取当前时间往后推几个月
     *
     * @param inputDate
     * @param number
     * @return
     */
    public static String getAfterMonth(String inputDate, int number) {
        Calendar c = Calendar.getInstance();//获得一个日历的实例
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date date = null;
        try {
            date = sdf.parse(inputDate);//初始日期
        } catch (Exception e) {

        }
        c.setTime(date);//设置日历时间
        c.add(Calendar.MONTH, number);//在日历的月份上增加6个月
        String strDate = sdf.format(c.getTime());//的到你想要得6个月后的日期
        return strDate;
    }

    public static void main(String[] args) {
        String date = getAfterMonth("2020-09-10", 3);
        System.out.println(date);
    }

}
