package com.msdw.tms.common.utils.py;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.common.utils.py
 * @ClassName: python
 * @Description: Java调用Python脚本辅助类
 * @Author: Maureen.Rong
 * @CreateDate: 2020/10/7 13:15
 * @UpdateDate: 2020/10/7 13:15
 * @Version: 1.0
 */
public class PyUtil {

    /*本地测试环境*/

    //这里指的是python环境的地址
    /*public static String path = "python";
    //生成图片
    public static String pyPathByPhoto = "C:\\Users\\Hello\\Desktop\\python\\photo.py";
    //正态Var
    public static String pyPathByVar = "C:\\Users\\Hello\\Desktop\\python\\getVar.py";
    //历史模拟法
    public static String historyPath = "C:\\Users\\Hello\\Desktop\\python\\getVarByHistory.py";
    //对冲前后生成图片
    public static String beforeAndAfter = "C:\\Users\\Hello\\Desktop\\python\\beforeAndAfterByHedging.py";*/
    /**
     * 线上测试环境
     */
    //这里指的是python环境的地址
    public static String path = "python";
    //生成图片
    public static String pyPathByPhoto = "/usr/local/sichuan/py/photo.py";
    //正态Var
    public static String pyPathByVar = "/usr/local/sichuan/py/getVar.py";
    //历史模拟法
    public static String historyPath = "/usr/local/sichuan/py/getVarByHistory.py";
    //对冲前后生成图片
    public static String beforeAndAfter = "/usr/local/sichuan/py/beforeAndAfterByHedging.py";


    /**
     * 动态传参调用Python脚本生成图片
     *
     * @param pyPath
     * @param path
     * @param params
     * @throws IOException
     */
    public static String getCodeByPhoto(String pyPath, String path, String... params) throws IOException {
        try {

            String[] args = new String[2 + params.length];
            args[0] = pyPath;
            args[1] = path;
            for (int x = 0; x < args.length; x++) {
                if (x > 1) {
                    args[x] = params[x - 2];
                }
            }
            //执行py文件
            Process proc = Runtime.getRuntime().exec(args);
            BufferedReader in = new BufferedReader(new InputStreamReader(proc.getInputStream()));
            String line = null;
            String url = "";


            while ((line = in.readLine()) != null) {
                url += line + ",";
                System.out.println("获取结果:" + line);
            }

            in.close();
            proc.waitFor();


            return url;

            //System.out.println("拼接后:" + url);


        } catch (Exception e) {
            e.printStackTrace();

        }
        return null;

    }


    /**
     * 动态传参调用Python脚本:正态Var
     *
     * @param pyPath
     * @param path
     * @param params
     * @throws IOException
     */
    public static String getVarCode(String pyPath, String path, String... params) throws IOException {
        try {

            String[] args = new String[2 + params.length];
            args[0] = pyPath;
            args[1] = path;
            for (int x = 0; x < args.length; x++) {
                if (x > 1) {
                    args[x] = params[x - 2];
                }
            }
            //执行py文件
            Process proc = Runtime.getRuntime().exec(args);
            BufferedReader in = new BufferedReader(new InputStreamReader(proc.getInputStream()));
            String line = null;

            String str = "";

            while ((line = in.readLine()) != null) {
                System.out.println("循环中输出:" + line);
                str += line + ",";
                //System.out.println("拼接后得到的字符串:" + str);
            }

            in.close();
            proc.waitFor();


            str = str.substring(0, str.length() - 1);

            //去除最后一个逗号
            str = str.substring(str.lastIndexOf(","));
            //截取第一个逗号后的字符串
            str = str.split(",")[1];

            return str;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }


    /**
     * 动态传参调用Python脚本:历史模拟
     *
     * @param pyPath
     * @param path
     * @param params
     * @throws IOException
     */
    public static String getCodeByHis(String pyPath, String path, String... params) throws IOException {
        try {

            String[] args = new String[2 + params.length];
            args[0] = pyPath;
            args[1] = path;
            for (int x = 0; x < args.length; x++) {
                if (x > 1) {
                    args[x] = params[x - 2];
                }
            }
            //执行py文件
            Process proc = Runtime.getRuntime().exec(args);
            BufferedReader in = new BufferedReader(new InputStreamReader(proc.getInputStream()));
            String line = null;

            String str = "";


            while ((line = in.readLine()) != null) {
                System.out.println(line);
                str += line;
            }

            in.close();
            proc.waitFor();

            return str;


        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * test
     *
     * @param args
     * @throws Exception
     */
    public static void main(String[] args) throws Exception {
        /**
         * photo  次数  天数  列表
         * getVarByHistory 置信水平（小数） 天数 列表
         * getVar  置信水平（小数） 天数 列表
         */
        //D:\myTool\py\python.exe
        //I为次数，t是天数，Z是传入进来的下单数*期货合约面值，arf为置信水平，ziliao为传入列表
        String print = getCodeByHis(path, historyPath,
                "0.95", "90", "6.3792,6.3756");

        System.out.println(">>>>>>>最后结果:" + print);
    }


}