package com.msdw.tms.common.utils.trading_rules;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

/**
 * @ProjectName: code_generator
 * @Package: com.create.generator
 * @ClassName: test1
 * @Description: java类作用描述
 * @Author: Maureen.Rong
 * @CreateDate: 2020/10/13 14:08
 * @UpdateDate: 2020/10/13 14:08
 * @Version: 1.0
 */
public class TradingDay {
    /*
     * 计算某年某月第几个星期几的日期
     * param wek 星期几
     * param num 第几个，10为最后一个
     */
    public static String getTheDate(int year, int month, int wek, int num) {
        Calendar time = Calendar.getInstance();
        time.set(Calendar.YEAR, year);
        time.set(Calendar.MONTH, month - 1);// 注意,Calendar对象默认一月为0
        int day = time.getActualMaximum(Calendar.DAY_OF_MONTH);// 本月份的天数
        List<String> list = new ArrayList<>();
        String dateTime = "";
        for (int i = 1; i <= day; i++) {
            time.set(Calendar.DAY_OF_MONTH, i);
            int weekd = time.get(Calendar.DAY_OF_WEEK) - 1;// 注意,Calendar对象默认星期天为1
            if (wek >= 1 && wek <= 7) {
                if (wek < 7) {
                    if (weekd == wek) {
                        String aaa = year + "-" + month + "-" + i;
                        list.add(aaa);
                    }
                } else {
                    if (weekd == 0) {
                        String aaa = year + "-" + month + "-" + i;
                        list.add(aaa);
                    }
                }

            }

        }
        if (list.size() > 0 && num <= 5) {
            dateTime = list.get(num - 1);
        } else if (num == 10) {
            dateTime = list.get(list.size() - 1);
        }
        return dateTime;
    }


    /**
     * 查询某年某月最后一天星期几
     *
     * @param yearMonth
     * @return
     */
    public static String getLastDayOfMonth(String yearMonth) {
        int year = Integer.parseInt(yearMonth.split("-")[0]);  //年
        int month = Integer.parseInt(yearMonth.split("-")[1]); //月
        Calendar cal = Calendar.getInstance();
        // 设置年份
        cal.set(Calendar.YEAR, year);
        // 设置月份
        // cal.set(Calendar.MONTH, month - 1);
        cal.set(Calendar.MONTH, month); //设置当前月的上一个月
        // 获取某月最大天数
        //int lastDay = cal.getActualMaximum(Calendar.DATE);
        int lastDay = cal.getMinimum(Calendar.DATE); //获取月份中的最小值，即第一天
        // 设置日历中月份的最大天数
        //cal.set(Calendar.DAY_OF_MONTH, lastDay);
        cal.set(Calendar.DAY_OF_MONTH, lastDay - 1); //上月的第一天减去1就是当月的最后一天
        // 格式化日期
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.format(cal.getTime());
    }


    /**
     * 判断当前日期是星期几<br>
     * <br>
     *
     * @param pTime 修要判断的时间<br>
     * @return dayForWeek 判断结果<br>
     * @Exception 发生异常<br>
     */
    public static int dayForWeek(String pTime) throws Exception {
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        Calendar c = Calendar.getInstance();
        c.setTime(format.parse(pTime));
        int dayForWeek = 0;
        if (c.get(Calendar.DAY_OF_WEEK) == 1) {
            dayForWeek = 7;
        } else {
            dayForWeek = c.get(Calendar.DAY_OF_WEEK) - 1;
        }
        return dayForWeek;
    }


    public static String getLastWeek(String time) {
        //查询本月最后一天星期几
        try {

            //last_day:查询本月最后一天是多少号 2020-10
            String last_day = getLastDayOfMonth(time);


            //截取年
            String year = last_day.substring(0, 4);
            //截取月
            String month = last_day.substring(5, 7);
            //截取日
            String day = last_day.substring(8);


            //查询最后一天是周几
            Integer weekday = dayForWeek(getLastDayOfMonth(time));


            switch (weekday) {
                case 1:
                    weekday = Integer.valueOf(day) - 3;
                    break;
                case 2:
                    weekday = Integer.valueOf(day) - 4;
                    break;
                case 3:
                    weekday = Integer.valueOf(day) - 5;
                    break;
                case 4:
                    weekday = Integer.valueOf(day) - 6;
                    break;
                case 5:
                    //等于周五不变
                    break;
                case 6:
                    weekday = Integer.valueOf(day) - 1;
                    break;
                case 7:
                    weekday = Integer.valueOf(day) - 2;
                    break;
            }

            return year + "-" + month + "-" + String.valueOf(weekday);

        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static void main(String[] args) {
        //2020年10月的第三个星期日
        //2020年的第3个星期 3前两个营业日
        //System.out.println(getTheDate(2020, 9, 3, 3));

        System.out.println("本月最后一周星期五：" + getLastWeek("2020-10"));
    }
}
