package com.msdw.tms.config;

import com.msdw.tms.interceptor.AuthorizedAspect;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.config
 * @ClassName: WebConfigurer
 * @Description: java类作用描述
 * @Author: Maureen.Rong
 * @CreateDate: 2020/10/22 11:21
 * @UpdateDate: 2020/10/22 11:21
 * @Version: 1.0
 */
@Configuration
public class WebConfigurer implements WebMvcConfigurer {

    @Autowired
    AuthorizedAspect authorizedAspect;

    /**
     * 这个方法用来添加拦截器，我们自己写好的拦截器需要通过这里添加注册才能生效
     * 静态资源不能直接写/static/**,这样还是会被拦截器拦截
     * 排除注册与一些无须登录可看的页面请求
     */
    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        /*registry.addInterceptor(authorizedAspect).addPathPatterns("/**")
                .excludePathPatterns("/swagger-ui.html")
                .excludePathPatterns("");*/
    }
}

