package com.msdw.tms.controller;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.msdw.tms.common.utils.R;
import com.msdw.tms.common.utils.TokenUtil;
import com.msdw.tms.entity.CdCacheEntity;
import com.msdw.tms.model.req.CdSaveCacheReq;
import com.msdw.tms.service.CdCacheService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


/**
 * @描述：步骤缓存记录表控制类
 * @作者: Rong
 * @日期: 2020-10-21
 */

@RestController
@RequestMapping("/chuanda/cache")
@Api(value = "API - 川大:步骤记录", tags = "川大子系统:步骤记录")
public class CdCacheController {

    @Autowired
    public CdCacheService service;


    /**
     * @描述: 新增步骤缓存
     * @入参:
     * @出参:
     * @作者: Rong
     * @日期: 2020-10-21
     **/
    @PostMapping("/save")
    @ApiOperation(value = "步骤缓存", response = CdSaveCacheReq.class)
    public R save(@RequestBody CdSaveCacheReq req) {
        int userId = TokenUtil.getUserId();
        return service.cache(userId, req.getStepNumber(), req.getJson());

    }

    /**
     * @描述: 根据用户id查询步骤
     * @入参:
     * @出参:
     * @作者: Rong
     * @日期: 2020-10-21
     **/
    @PostMapping("/list")
    @ApiOperation(value = "查询步骤/实验报告", response = CdCacheEntity.class)
    public R list() {
        int userId = TokenUtil.getUserId();
        QueryWrapper<CdCacheEntity> wrapper = new QueryWrapper<>();
        wrapper.eq("user_id", userId);
        CdCacheEntity cache = service.getOne(wrapper);


        cache.getStep1();
        return R.ok().put("data", cache);

    }


    public static void main(String[] args) {
        javaToJSON();
    }

    public static void javaToJSON() {
        JSONObject jsonObject = new JSONObject();

        jsonObject.put("userId", "1");
        System.out.println("java--->json \n " + jsonObject.toString());
    }


}

