package com.msdw.tms.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.msdw.tms.common.utils.R;
import com.msdw.tms.entity.CdPoint;
import com.msdw.tms.entity.CdPointChildren;
import com.msdw.tms.service.CdPointChildrenService;
import com.msdw.tms.service.CdPointService;
import io.swagger.annotations.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;


/**
 * @描述：控制类
 * @作者: Rong
 * @日期: 2021-01-11
 */
@RestController
@RequestMapping("/point")
@Api(value = "API - 判分点:CdPointController", tags = "判分点:")
public class CdPointController {

    @Autowired
    public CdPointService service;

    @Autowired
    public CdPointChildrenService childrenService;

    /**
     * @描述: 查询一级目录
     * @入参:
     * @出参:
     * @作者: Rong
     * @日期: 2021-01-11
     **/
    @CrossOrigin
    @GetMapping("/firstLevel")
    @ApiOperation(value = " 查询一级目录", response = CdPoint.class)
    public R listByEntity() {
        QueryWrapper<CdPoint> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("parent_id", 0);

        List<CdPoint> pointsList = service.list(queryWrapper);

        return R.ok().put("list", pointsList);
    }


    /**
     * @描述: 查询二级目录
     * @入参:
     * @出参:
     * @作者: Rong
     * @日期: 2021-01-11
     **/
    @CrossOrigin
    @GetMapping("/secondaryLevel")
    @ApiOperation(value = " 查询二级目录", response = CdPoint.class)
    public R secondaryLevel(@RequestParam("id") @ApiParam(value = "序号") Integer id) {
        QueryWrapper<CdPoint> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("parent_id", id);
        List<CdPoint> pointsList = service.list(queryWrapper);
        return R.ok().put("list", pointsList);
    }


    /**
     * @描述: 查询三级目录
     * @入参:
     * @出参:
     * @作者: Rong
     * @日期: 2021-01-11
     **/
    @CrossOrigin
    @GetMapping("/thirdLevel")
    @ApiOperation(value = " 查询三级目录", response = CdPointChildren.class)
    public R thirdLevel(@RequestParam("id") @ApiParam(value = "序号") Integer id) {
        QueryWrapper<CdPointChildren> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("point_id", id);
        List<CdPointChildren> pointsList = childrenService.list(queryWrapper);
        return R.ok().put("list", pointsList);
    }

}

