package com.msdw.tms.controller;

import com.msdw.tms.common.utils.R;
import com.msdw.tms.common.utils.TokenUtil;
import com.msdw.tms.entity.CdFuturesConfigureEntity;
import com.msdw.tms.model.req.CdTransferWarehouseReq;
import com.msdw.tms.service.CdTransferWarehouseRecordService;
import com.msdw.tms.service.CdUserAssetsService;
import com.msdw.tms.service.CdUserOptionAccountService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


/**
 * @描述：调仓记录表控制类
 * @作者: Rong
 * @日期: 2020-10-10
 */
@RestController
@RequestMapping("/chuanda/transferWarehouseRecord")
@Api(value = "API - 川大:调仓相关操作", tags = "川大子系统:调仓相关操作")
public class CdTransferWarehouseRecordController {

    @Autowired
    public CdTransferWarehouseRecordService service;

    @Autowired
    public CdUserOptionAccountService optionAccountService;

    @Autowired
    public CdUserAssetsService assetsService;

    /**
     * @描述: 调仓操作
     * @入参:
     * @出参:
     * @作者: Rong
     * @日期: 2020-10-10
     **/
    @PostMapping("/modify")
    @ApiOperation(value = "调仓操作")
    public R modify(@RequestBody CdTransferWarehouseReq req) {
        if (req.getEntrustNumber() <= 0) {
            return R.error("委托数量不能小于等于0!");
        }
        CdFuturesConfigureEntity entity = new CdFuturesConfigureEntity();
        entity.setUserId(TokenUtil.getUserId());
        entity.setId(req.getId());
        /*entity.setTradingDirection(req.getTradingDirection());*/
        entity.setStatus(req.getStatus());
        entity.setEntrustPrice(req.getEntrustPrice());
        entity.setEntrustNumber(req.getEntrustNumber());
        entity.setTradableNumber(req.getTradableNumber());
        return service.add(entity);
    }

}

