package com.msdw.tms.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @描述：账户流水记录
 * @作者: Rong
 * @日期: 2020-10-15
 */
@Data
@ApiModel(value = "账户流水记录")
@TableName("cd_bank_statements")
public class CdBankStatementsEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;
    @ApiModelProperty(value = "用户id")
    @NotBlank(message = "用户id不能为空")
    private Integer userId;

    @ApiModelProperty(value = "类型（1银行账户 2期货账户）")
    private Integer type;

    @ApiModelProperty(value = "币种")
    private String coinType;

    @ApiModelProperty(value = "改变前金额")
    private BigDecimal beforeAmount;

    @ApiModelProperty(value = "金额")
    private BigDecimal amountMoney;

    @ApiModelProperty(value = "改变后金额")
    private BigDecimal afterAmount;

    @ApiModelProperty(value = "流水类型(1:转账 2:流水)")
    private Integer transferType;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "创建时间")
    private String createTime;

    @ApiModelProperty(value = "修改时间")
    private String updateTime;


}