package com.msdw.tms.entity;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * @描述：实验数据
 * @作者: Rong
 * @日期: 2020-10-20
 */
@Data
@ApiModel(value = "实验数据")
@TableName("cd_experimental")
public class CdExperimentalEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Excel(name = "序号", orderNum = "1", mergeVertical = true, isImportField = "id", width = 15)
    @ApiModelProperty(value = "主键")
    private Integer id;

    @ApiModelProperty(value = "用户id")
    private Integer userId;

    @ApiModelProperty(value = "实验类型(0正态Var，1历史模拟，2蒙特卡洛)")
    private Integer type;


    @Excel(name = "汇率类型", orderNum = "2", mergeVertical = true, isImportField = "exchangeRate", width = 15)
    @ApiModelProperty(value = "汇率类型")
    private String exchangeRate;


    @Excel(name = "样本数据", orderNum = "3", mergeVertical = true, isImportField = "sampleData", width = 25)
    @ApiModelProperty(value = "样本数据")
    private String sampleData;


    @Excel(name = "置信水平", orderNum = "4", mergeVertical = true, isImportField = "confidenceLevel", width = 15)
    @ApiModelProperty(value = "置信水平")
    private String confidenceLevel;

    @Excel(name = "持有天数", orderNum = "5", mergeVertical = true, isImportField = "validPeriod", width = 15)
    @ApiModelProperty(value = "持有天数")
    private String validPeriod;

    @ApiModelProperty(value = "实验次数")
    private Integer experimentsNumber;


    @Excel(name = "Var值", orderNum = "6", mergeVertical = true, isImportField = "varCode", width = 20)
    @ApiModelProperty(value = "Var值")
    private String varCode;

    @ApiModelProperty(value = "汇率走势图")
    private String trendChart;

    @ApiModelProperty(value = "汇率损益分布图")
    private String profitLossDistribution;

    @Excel(name = "创建时间", orderNum = "7", mergeVertical = true, isImportField = "creatTime", width = 20)
    @ApiModelProperty(value = "创建时间")
    private String creatTime;

    @ApiModelProperty(value = "修改时间")
    private String updateTime;


}