package com.msdw.tms.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @描述：调仓记录表
 * @作者: Rong
 * @日期: 2020-10-10
 */
@Data
@ApiModel(value = "操作记录表")
@TableName("cd_transfer_warehouse_record")
public class CdTransferWarehouseRecordEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    private Integer id;

    @ApiModelProperty(value = "头寸主键")
    private Integer cid;

    @ApiModelProperty(value = "用户id")
    @NotNull(message = "用户id不能为空")
    private Integer userId;

    @ApiModelProperty(value = "金额")
    private BigDecimal balance;

    @ApiModelProperty(value = "买卖方向（0开仓 1平仓）")
    private Integer direction;

    @ApiModelProperty(value = "委托类型(0市价 1限价)")
    private Integer type;

    @ApiModelProperty(value = "委托手数")
    private BigDecimal number;

    @ApiModelProperty(value = "创建时间")
    private String createTime;

    @ApiModelProperty(value = "修改时间")
    private String updateTime;


}