package com.msdw.tms.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @描述：用户银行账户
 * @作者: Rong
 * @日期: 2020-10-10
 */
@Data
@ApiModel(value = "用户银行账户")
@TableName("cd_user_assets")
public class CdUserAssetsEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;

    @ApiModelProperty(value = "用户id")
    private Long userId;

    @ApiModelProperty(value = "初始资金")
    private BigDecimal initialBalance;

    @ApiModelProperty(value = "可用资金")
    private BigDecimal balance;

    @ApiModelProperty(value = "创建时间")
    private String createTime;

    @ApiModelProperty(value = "修改时间")
    private String updateTime;


    public CdUserAssetsEntity() {
    }

    public CdUserAssetsEntity(Long userId, BigDecimal initialBalance, BigDecimal balance, String createTime ) {
        this.userId = userId;
        this.initialBalance = initialBalance;
        this.balance = balance;
        this.createTime = createTime;
    }
}