package com.msdw.tms.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @描述：期货期权账户
 * @作者: Rong
 * @日期: 2020-10-10
 */
@Data
@ApiModel(value = "期货期权账户")
@TableName("cd_user_option_account")
public class CdUserOptionAccountEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;

    @ApiModelProperty(value = "用户id")
    private Long userId;

    @ApiModelProperty(value = "可用资金")
    private BigDecimal balance;

    @ApiModelProperty(value = "冻结资金")
    private BigDecimal forzenBalance;

    @ApiModelProperty(value = "占用保证金")
    private BigDecimal depositBalance;

    @ApiModelProperty(value = "创建时间")
    private String createTime;

    @ApiModelProperty(value = "修改时间")
    private String updateTime;

    @ApiModelProperty(value = "总资产")
    private transient BigDecimal totalAssets;

    public CdUserOptionAccountEntity() {
    }

    public CdUserOptionAccountEntity(Long userId, BigDecimal balance, BigDecimal forzenBalance, BigDecimal depositBalance, String createTime) {
        this.userId = userId;
        this.balance = balance;
        this.forzenBalance = forzenBalance;
        this.depositBalance = depositBalance;
        this.createTime = createTime;
    }
}