package com.msdw.tms.entity;

import cn.afterturn.easypoi.excel.annotation.Excel;
import cn.afterturn.easypoi.excel.annotation.ExcelTarget;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

/**
 * @描述：外汇市场人民币品种
 * @作者: Rong
 * @日期: 2020-09-28
 */

//@EqualsAndHashCode(callSuper = true)
@ExcelTarget("whsc_renminbipinzhong")
@TableName("whsc_renminbipinzhong")
@ApiModel(value = "外汇市场人民币品种")

public class WhscRenminbipinzhongEntity implements Serializable {

    private static final long serialVersionUID = 1L;


    @TableId("id")
    @Excel(name = "编号", orderNum = "1", mergeVertical = true, isImportField = "id", width = 15)
    private Integer id;


    @TableField("e_name")
    @Excel(name = "代码", orderNum = "2", mergeVertical = true, isImportField = "eName", width = 15)
    @ApiModelProperty(value = "代码")
    private String eName;

    @TableField("name")
    @Excel(name = "名称", orderNum = "3", mergeVertical = true, isImportField = "name", width = 30)
    @ApiModelProperty(value = "名称")
    private String name;

    @TableField("last_price")
    @Excel(name = "最新价", orderNum = "4", mergeVertical = true, isImportField = "lastPrice", width = 15)
    @ApiModelProperty(value = "最新价")
    private Double lastPrice;


    @TableField("ud_price")
    @Excel(name = "涨跌额", orderNum = "5", mergeVertical = true, isImportField = "udPrice", width = 15)
    @ApiModelProperty(value = "涨跌额")
    private Double udPrice;


    @TableField("u")
    @Excel(name = "涨跌幅", orderNum = "6", mergeVertical = true, isImportField = "u", width = 15)
    @ApiModelProperty(value = "涨跌幅")
    private String u;


    @TableField("t_open")
    @Excel(name = "今开", orderNum = "15", mergeVertical = true, isImportField = "tOpen", width = 15)
    @ApiModelProperty(value = "今开")
    private Double tOpen;


    @TableField("high")
    @Excel(name = "最高", orderNum = "8", mergeVertical = true, isImportField = "high", width = 15)
    @ApiModelProperty(value = "最高")
    private Double high;


    @TableField("low")
    @Excel(name = "最低", orderNum = "9", mergeVertical = true, isImportField = "low", width = 15)
    @ApiModelProperty(value = "最低")
    private Double low;

    @TableField("y_finish")
    @Excel(name = "昨结", orderNum = "10", mergeVertical = true, isImportField = "yFinish", width = 15)
    @ApiModelProperty(value = "昨结")
    private Double yFinish;


    @TableField("date")
    @Excel(name = "时间", orderNum = "11", mergeVertical = true, isImportField = "date", width = 25)
    @ApiModelProperty(value = "时间")
    private String date;


    @ApiModelProperty(value = "汇率类型")
    private transient String typeName;


    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String geteName() {
        return eName;
    }

    public void seteName(String eName) {
        this.eName = eName;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Double getLastPrice() {
        return lastPrice;
    }

    public void setLastPrice(Double lastPrice) {
        this.lastPrice = lastPrice;
    }

    public Double getUdPrice() {
        return udPrice;
    }

    public void setUdPrice(Double udPrice) {
        this.udPrice = udPrice;
    }

    public String getU() {
        return u;
    }

    public void setU(String u) {
        this.u = u;
    }

    public Double gettOpen() {
        return tOpen;
    }

    public void settOpen(Double tOpen) {
        this.tOpen = tOpen;
    }

    public Double getHigh() {
        return high;
    }

    public void setHigh(Double high) {
        this.high = high;
    }

    public Double getLow() {
        return low;
    }

    public void setLow(Double low) {
        this.low = low;
    }

    public Double getyFinish() {
        return yFinish;
    }

    public void setyFinish(Double yFinish) {
        this.yFinish = yFinish;
    }

    public String getDate() {
        return date;
    }

    public void setDate(String date) {
        this.date = date;
    }

    public String getTypeName() {
        return typeName;
    }

    public void setTypeName(String typeName) {
        this.typeName = typeName;
    }
}