package com.msdw.tms.entity.request;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;

/**
 * 试题的基本信息表
 * 
 * @author gongsj
 */
@Data
@ApiModel(value = "QuestionsAddRequest", description = "添加试题请求体对象")
public class QuestionsAddRequest {
	/**
	 * 题型：1、单选题，2、多选题，3、判断题
	 */
	@ApiModelProperty(value = "题型：1、单选题，2、多选题，3、判断题", name = "questionType", example = "1", required = true)
	private Integer questionType;
	/**
	 * 题干信息
	 */
	@ApiModelProperty(value = "题干信息", name = "questionStem", example = "世界上最大的哺乳动物是什么？", required = true)
	private String questionStem;
	/**
	 * A选项内容
	 */
	@ApiModelProperty(value = "A选项内容", name = "optionA", example = "鲸鱼")
	private String optionA;
	/**
	 * B选项内容
	 */
	@ApiModelProperty(value = "B选项内容", name = "optionB", example = "鲨鱼")
	private String optionB;
	/**
	 * C选项内容
	 */
	@ApiModelProperty(value = "C选项内容", name = "optionC", example = "河马")
	private String optionC;
	/**
	 * D选项内容
	 */
	@ApiModelProperty(value = "D选项内容", name = "optionD", example = "豹子")
	private String optionD;
	/**
	 * E选项内容
	 */
	@ApiModelProperty(value = "E选项内容", name = "optionE", example = "大象")
	private String optionE;
	/**
	 * F选项内容
	 */
	@ApiModelProperty(value = "F选项内容", name = "optionF", example = "老虎")
	private String optionF;
	/**
	 * 正确答案
	 */
	@ApiModelProperty(value = "正确答案", name = "answer", example = "A", required = true)
	private String answer;
	/**
	 * 答案解析
	 */
	@ApiModelProperty(value = "答案解析", name = "answerAnalysis", example = "鲸鱼是最大的哺乳动物")
	private String answerAnalysis;
}
