package com.msdw.tms.entity.request;

import com.msdw.tms.common.utils.poi.ExcelAttribute;
import lombok.Data;
import lombok.ToString;

/**
 * 试题的基本信息表
 *
 * @author gongsj
 */
@Data
@ToString
public class QuestionsImportRequest {
    /**
     * 第几行
     */
    private Integer index;

    /**
     * 题干，问题描述
     */
    @ExcelAttribute(sort = 0)
    private String questionStem;
    /**
     * 题型
     */
    @ExcelAttribute(sort = 1)
    private String questionTypeName;
    /**
     * 选项A
     */
    @ExcelAttribute(sort = 2)
    private String optionA;
    /**
     * 选项B
     */
    @ExcelAttribute(sort = 3)
    private String optionB;
    /**
     * 选项C
     */
    @ExcelAttribute(sort = 4)
    private String optionC;
    /**
     * 选项D
     */
    @ExcelAttribute(sort = 5)
    private String optionD;
    /**
     * 选项E
     */
    @ExcelAttribute(sort = 6)
    private String optionE;
    /**
     * 选项F
     */
    @ExcelAttribute(sort = 7)
    private String optionF;
    /**
     * 正确答案
     */
    @ExcelAttribute(sort = 8)
    private String answer;
    /**
     * 答案解析
     */
    @ExcelAttribute(sort = 9)
    private String answerAnalysis;

    public String toStringForCompare() {
        return questionStem +
                questionTypeName +
                optionA +
                optionB +
                optionC +
                optionD +
                optionE +
                optionF;
    }
}
