package com.msdw.tms.entity.request;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 试题的基本信息表
 *
 * @author gongsj
 */
@Data
@ApiModel(value = "QuestionsQueryRequest", description = "条件查询请求对象")
public class QuestionsQueryRequest {

    /**
     * 题干，问题描述
     */
    @ApiModelProperty(value = "题干，问题描述", name = "questionStem", example = "世界上最大的哺乳动物是什么？")
    private String questionStem;

    /**
     * 题型
     */
    @ApiModelProperty(value = "题型：1、单选题，2、多选题，3、判断题", name = "questionType", example = "1")
    private Integer questionType;
    // /**
    //  * 参考答案
    //  */
    // private String answer;
    // /**
    //  * 答案解析
    //  */
    // private String answerAnalysis;
    // /**
    //  * 创建时，修改时间即为创建时间，修改时间用于前端显示和排序
    //  */
    // private Date modifyTime;
}
