package com.msdw.tms.entity.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @描述：外汇期货平仓绩效
 * @作者: Rong
 * @日期: 2020-10-12
 */
@Data
@ApiModel(value = "外汇期货平仓绩效")
public class CdFuturesConfigureEntityVo {


    //序号
    @TableId(type = IdType.AUTO)
    private Integer id;

    //代码
    @ApiModelProperty(value = "代码")
    private String eName;

    //合约名称
    @ApiModelProperty(value = "名称")
    private String name;

    //头寸部位
    @ApiModelProperty(value = "交易方向(0空头,1多头)")
    private String tradingDirection;

    //开仓价格(委托价格)
    @ApiModelProperty(value = "开仓价格/委托价格")
    private BigDecimal entrustPrice;


    //平仓价格
    @ApiModelProperty(value = "平仓价格")
    private BigDecimal closeRate;

    //资产市值1
    @ApiModelProperty(value = "资产市值1")
    private BigDecimal marketValue1;

    //资产市值2
    @ApiModelProperty(value = "资产市值2")
    private BigDecimal marketValue2;

    //数量(委托数量)
    @ApiModelProperty(value = "数量(委托数量)")
    private Integer entrustNumber;

    //盈亏
    @ApiModelProperty(value = "盈亏")
    private BigDecimal wh_pl;


    @ApiModelProperty(value = "开仓时间")
    private String createTime;

    @ApiModelProperty(value = "平仓时间")
    private String updateTime;

    @ApiModelProperty(value = "最后交易日")
    private String tradeTime;


}