package com.msdw.tms.interceptor;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.interceptor
 * @ClassName: AuthorizedAspect
 * @Description: java类作用描述
 * @Author: Maureen.Rong
 * @CreateDate: 2020/10/22 10:01
 * @UpdateDate: 2020/10/22 10:01
 * @Version: 1.0
 */

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


@Component
public class AuthorizedAspect implements HandlerInterceptor {
    @Autowired
    private StringRedisTemplate redisTemplate;


    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        //去redis里查询
        String token = request.getHeader("token");

        String tokenValue = redisTemplate.opsForValue().get("token:" + token);
        if (StringUtils.isEmpty(tokenValue)) {
            System.err.println("【登录校验】Redis中查不到token");
            return false;
        }
        return true;
    }

    @Override
    public void postHandle(HttpServletRequest request, HttpServletResponse response, Object handler, ModelAndView modelAndView) throws Exception {

    }

    @Override
    public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {

    }



    /*@Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        //去redis里查询
        String tokenValue = redisTemplate.opsForValue().get("token");
        if (StringUtils.isEmpty(tokenValue)) {
            log.warn("【登录校验】Redis中查不到token");
            return false;
        }
        return true;
    }*/


    //切面拦截器，拦截订单接口请求中是否能查询到token
   /* @Pointcut("execution(public * com.msdw.tms.controller.*(..))") //切入点
    public void verify() {
    }

    @Before("verify()")  //在请求之前
    public R doVerify() {
        AuthCustomize authCustomize;
        ServletRequestAttributes attributes = (ServletRequestAttributes) RequestContextHolder.getRequestAttributes();
        HttpServletRequest request = attributes.getRequest();
        String token = request.getHeader("token");

        //去redis里查询
        String tokenValue = redisTemplate.opsForValue().get("token:" + token);
        if (StringUtils.isEmpty(tokenValue)) {
            log.warn("【登录校验】Redis中查不到token");
            return R.error("Redis中查不到token");
        }
        return R.ok();
    }*/




}
