package com.msdw.tms.model.req;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.model.req
 * @ClassName: CdGetAccountInfoReq
 * @Description: 期权账户请求参数
 * @Author: Maureen.Rong
 * @CreateDate: 2020/10/29 11:06
 * @UpdateDate: 2020/10/29 11:06
 * @Version: 1.0
 */
@Data
@ApiModel("期权账户请求参数")
public class CdGetAccountInfoReq {

    @ApiModelProperty(value = "委托价格")
    @NotNull(message = "委托价格不能为空")
    private BigDecimal entrustPrice;

    @ApiModelProperty(value = "委托数量")
    @NotNull(message = "委托数量不能为空")
    private Integer entrustNumber;

    @ApiModelProperty(value = "交易方向(0空头,1多头)")
    @NotBlank(message = "交易方向不能为空")
    private Integer tradingDirection;

    @ApiModelProperty(value = "合约id")
    @NotBlank(message = "合约id为空")
    private Integer id;
}
