package com.msdw.tms.model.req;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

@Data
@ApiModel("开仓请求参数")
public class CdOpenPositionReq {
    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "合约表主键")
    @NotNull(message = "合约表主键不能为空")
    private Integer pid;

    @ApiModelProperty(value = "交易方向(0空头,1多头)")
    @NotBlank(message = "交易方向不能为空")
    private Integer tradingDirection;

    @ApiModelProperty(value = "最新价格")
    @NotBlank(message = "最新价格不能为空")
    private BigDecimal newestPrice;

    @ApiModelProperty(value = "委托价格")
    @NotNull(message = "委托价格不能为空")
    private BigDecimal entrustPrice;

    @ApiModelProperty(value = "委托数量")
    @NotNull(message = "委托数量不能为空")
    private Integer entrustNumber;

    @ApiModelProperty(value = "所需资金")
    private BigDecimal fundingNeeded;


}
