package com.msdw.tms.model.req;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.mode.req
 * @ClassName: SimulationReq
 * @Description: 根据选择的模拟法传值获取相应数据
 * @Author: Maureen.Rong
 * @CreateDate: 2020/10/23 13:29
 * @UpdateDate: 2020/10/23 13:29
 * @Version: 1.0
 */
@Data
public class CdSimulationReq {

    @ApiModelProperty(value = "类型(0.正态VaR 1.历史模拟法 2.蒙特卡洛模拟法) 传数字")
    private Integer type;
    @ApiModelProperty(value = "要筛选的币种")
    private String name;
    @ApiModelProperty(value = "样本区间开始时间")
    private String startTime;
    @ApiModelProperty(value = "样本区间结束时间：由第二步骤中选择的日期")
    private String endTime;
    @ApiModelProperty(value = "置信水平")
    private String confidenceLevel;
    @ApiModelProperty(value = "持有效")
    private String validity;
    @ApiModelProperty(value = "实验次数")
    private String experimentsNumber;


}
