package com.msdw.tms.model.req;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.model.req
 * @ClassName: CdTransferRecordsReq
 * @Description: 转账记录请求参数
 * @Author: Maureen.Rong
 * @CreateDate: 2020/10/23 16:30
 * @UpdateDate: 2020/10/23 16:30
 * @Version: 1.0
 */
@Data
@ApiModel(value = "转账记录", description = "查询对象封装")
public class CdTransferRecordsReq {
    /**
     * @ApiImplicitParams({
     * @ApiImplicitParam(name = "pageNum", value = "pageIndex:当前页数", required = true, dataType = "String", paramType = "query"),
     * @ApiImplicitParam(name = "pageSize", value = "pageSize：当前页需要显示的数量", required = true, dataType = "String", paramType = "query"),
     * @ApiImplicitParam(name = "startTime", value = "开始时间", required = false, dataType = "String", paramType = "query"),
     * @ApiImplicitParam(name = "endTime", value = "结束时间", required = false, dataType = "String", paramType = "query")
     * })
     */

    @ApiModelProperty(value = "开始时间")
    private String startTime;
    @ApiModelProperty(value = "结束时间")
    private String endTime;
    @ApiModelProperty(value = "当前页数")
    private Integer pageNum;
    @ApiModelProperty(value = "当前页需要显示的数量")
    private Integer pageSize;


}
