package com.msdw.tms.model.req;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

@Data
@ApiModel("调仓请求参数")
public class CdTransferWarehouseReq {

    @ApiModelProperty(value = "主键", required = false)
    private Integer id;

   /* @ApiModelProperty(value = "交易方向(0空头,1多头)")
    @NotBlank(message = "交易方向不能为空")
    private Integer tradingDirection;*/

    @ApiModelProperty(value = "买卖方向:0.开仓 1.平仓")
    private Integer status;

    @ApiModelProperty(value = "委托价格")
    @NotNull(message = "委托价格不能为空")
    private BigDecimal entrustPrice;

    @ApiModelProperty(value = "委托手数")
    @NotNull(message = "委托数量不能为空")
    private Integer entrustNumber;

    @ApiModelProperty(value = "可交易数量")
    @NotNull(message = "可交易数量不能为空")
    private BigDecimal tradableNumber;


}
