package com.msdw.tms.model.req;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;

@Data
public class QhscGangjiaosuoReq {

    //String name, String date, Integer pageNum, Integer pageSize

    /**
     * @ApiImplicitParams({
     * @ApiImplicitParam(name = "pageNum", value = "pageIndex:当前页数", required = true, dataType = "String", paramType = "query"),
     * @ApiImplicitParam(name = "pageSize", value = "pageSize：当前页需要显示的数量", required = true, dataType = "String", paramType = "query"),
     * @ApiImplicitParam(name = "name", value = "要筛选的币种", required = false, dataType = "String", paramType = "query"),
     * @ApiImplicitParam(name = "date", value = "日期(步骤二选中的时间)", required = false, dataType = "String", paramType = "query")
     * })
     */

    @ApiModelProperty(value = "要筛选的币种")
    private String name;

    @ApiModelProperty(value = "步骤二选中的时间")
    @NotEmpty(message = "时间不能为空")
    private String date;

    @ApiModelProperty(value = "当前页数")
    @NotEmpty(message = "当前页数不能为空")
    private Integer pageNum;

    @ApiModelProperty(value = "当前页需要显示的数量")
    @NotEmpty(message = "当前页需要显示的数量不能为空")
    private Integer pageSize;


}
