package com.msdw.tms.model.resp;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.model.req
 * @ClassName: CdAccountInfoResp
 * @Description: java类作用描述
 * @Author: Maureen.Rong
 * @CreateDate: 2020/10/26 11:13
 * @UpdateDate: 2020/10/26 11:13
 * @Version: 1.0
 */
@ApiModel(value = "期货期权账户返回参数")
@Data
public class CdAccountInfoResp {

    @ApiModelProperty(value = "总资产")
    private BigDecimal totalAssets;

    @ApiModelProperty(value = "可用资金")
    private BigDecimal balance;

    @ApiModelProperty(value = "资产市值")
    private BigDecimal marketAssets;

    @ApiModelProperty(value = "浮动盈亏")
    private BigDecimal floatingPL;

    @ApiModelProperty(value = "占用保证金")
    private BigDecimal depositBalance;

    @ApiModelProperty(value = "冻结资金")
    private BigDecimal forzenBalance;


    /**
     * 待开仓信息
     */
    @ApiModelProperty(value = "序号")
    private Integer id;

    @ApiModelProperty(value = "合约名称")
    private transient String name;

    @ApiModelProperty(value = "代码")
    private transient String ename;

    @ApiModelProperty(value = "交易方向(0空头,1多头)")
    private Integer tradingDirection;

    @ApiModelProperty(value = "创建时间")
    private String createTime;

    @ApiModelProperty(value = "最后交易日")
    private String tradeTime;

    @ApiModelProperty(value = "所需资金")
    private BigDecimal fundingNeeded;


}
