package com.msdw.tms.model.resp;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.model.resp
 * @ClassName: CdAfterHedgingResp
 * @Description: 对冲后返回对象
 * @Author: Maureen.Rong
 * @CreateDate: 2020/10/30 9:17
 * @UpdateDate: 2020/10/30 9:17
 * @Version: 1.0
 */
@Data
@ApiModel("对冲后损益情况返回信息")
public class CdAfterHedgingResp {

    @ApiModelProperty(value = "汇率类型")
    private String name;

    @ApiModelProperty(value = "样本区间:开始时间")
    private String startTime;

    @ApiModelProperty(value = "样本区间:结束时间")
    private String endTime;

    @ApiModelProperty(value = "持有效")
    private String effective;

    @ApiModelProperty("置信水平")
    private String confidenceLevel;

    @ApiModelProperty("实验次数")
    private String experimentNum;

    @ApiModelProperty("对冲前损益分布图")
    private String beforeHedgingUrl;

    @ApiModelProperty("对冲后损益分布图")
    private String afterHedgingUrl;

}
