package com.msdw.tms.model.resp;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.model.resp
 * @ClassName: CdBeforeHedgingResp
 * @Description: java类作用描述
 * @Author: Maureen.Rong
 * @CreateDate: 2020/10/28 14:26
 * @UpdateDate: 2020/10/28 14:26
 * @Version: 1.0
 */
@ApiModel(value = "返回信息", description = "外汇现货盈亏返回对象")
@Data
public class CdBeforeHedgingResp {


    @ApiModelProperty(value = "序号", required = false)
    private Integer id;

    @ApiModelProperty(value = "交易方向(0空头卖,1多头买)")
    private String tradingDirection;

    @ApiModelProperty(value = "(持仓可用)委托数量")
    private Integer entrustNumber;

    @ApiModelProperty(value = "持仓状态(0.开仓 1.平仓)")
    private String status;

    @ApiModelProperty(value = "开仓时间")
    private String createTime;

    @ApiModelProperty(value = "平仓时间")
    private String updateTime;

    @ApiModelProperty(value = "合约名称")
    private String name;

    @ApiModelProperty(value = "开仓价格")
    private BigDecimal entrustPrice;

    @ApiModelProperty(value = "平仓价格")
    private BigDecimal closeRate;

    @ApiModelProperty(value = "金额外币(开仓)")
    private BigDecimal foreignCurrencyByOpen;

    @ApiModelProperty(value = "金额外币(平仓)")
    private BigDecimal foreignCurrencyByClose;

    @ApiModelProperty(value = "所需资金(开仓)")
    private BigDecimal neededPriceByOpen;

    @ApiModelProperty(value = "所需资金(平仓)")
    private BigDecimal neededPriceByClose;

    @ApiModelProperty(value = "盈亏")
    private BigDecimal profitLoss;

    @ApiModelProperty(value = "汇率1")
    private BigDecimal exchangeRate1;

    @ApiModelProperty(value = "汇率2")
    private BigDecimal exchangeRate2;


}
