package com.msdw.tms.model.resp;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.model.req
 * @ClassName: CdFxSpotReq
 * @Description: 外汇现货返回类
 * @Author: Maureen.Rong
 * @CreateDate: 2020/10/27 9:19
 * @UpdateDate: 2020/10/27 9:19
 * @Version: 1.0
 */
@Data
public class CdFxSpotResp {

    @ApiModelProperty(value = "序号", required = false)
    @TableId(type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "用户id")
    @NotNull(message = "用户id不能为空")
    private Integer userId;

    @ApiModelProperty(value = "合约表主键")
    @NotNull(message = "合约表主键不能为空")
    private Integer pid;

    @ApiModelProperty(value = "交易方向(0空头,1多头)")
    @NotBlank(message = "交易方向不能为空")
    private Integer tradingDirection;

    @ApiModelProperty(value = "最新价格")
    @NotBlank(message = "最新价格不能为空")
    private BigDecimal newestPrice;

    @ApiModelProperty(value = "委托价格")
    @NotNull(message = "委托价格不能为空")
    private BigDecimal entrustPrice;

    @ApiModelProperty(value = "委托数量")
    @NotNull(message = "委托数量不能为空")
    private Integer entrustNumber;

    @ApiModelProperty(value = "可交易数量")
    @NotNull(message = "可交易数量不能为空")
    private BigDecimal tradableNumber;


    @ApiModelProperty(value = "0.开仓 1.平仓")
    private Integer status;

    @ApiModelProperty(value = "是否自动平仓（0否 1是）")
    private Integer type;

    @ApiModelProperty(value = "浮动盈亏")
    private BigDecimal floatingPl;

    @ApiModelProperty(value = "开仓时间")
    @NotBlank(message = "开仓时间不能为空")
    private String createTime;

    @ApiModelProperty(value = "平仓时间")
    @NotBlank(message = "平仓时间不能为空")
    private String updateTime;

    @ApiModelProperty(value = "最后交易日")
    @NotBlank(message = "最后交易日不能为空")
    private String tradeTime;


    @ApiModelProperty(value = "平仓价格")
    @NotBlank(message = "平仓价格不能为空")
    private BigDecimal closeRate;
}
