package com.msdw.tms.model.resp;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.model.resp
 * @ClassName: CdGetDetailByIdResp
 * @Description: java类作用描述
 * @Author: Maureen.Rong
 * @CreateDate: 2020/10/27 18:45
 * @UpdateDate: 2020/10/27 18:45
 * @Version: 1.0
 */
@Data
public class CdGetDetailByIdResp {

    @ApiModelProperty(value = "合约表主键")
    private Integer pid;
    @ApiModelProperty(value = "合约名称")
    private String name;

    @ApiModelProperty(value = "最新价格")
    private BigDecimal newestPrice;

    @ApiModelProperty(value = "委托价格(暂默认为最新价格)")
    private BigDecimal entrustPrice;

    @ApiModelProperty(value = "委托数量(这里默认为1)")
    private Integer entrustNumber;

    @ApiModelProperty(value = "可交易数量")
    private String tradableNumber;

    @ApiModelProperty(value = "预冻结保证金")
    private BigDecimal preFreezingMargin;

    @ApiModelProperty(value = "预冻结手续费")
    private BigDecimal preFreezingFrozen;

    @ApiModelProperty(value = "冻结资金")
    private BigDecimal frozenPrice;

    @ApiModelProperty(value = "交易单位")
    private Integer tradingUnit;

    @ApiModelProperty(value = "交易保证金")
    private BigDecimal tradingBond;


}
