package com.msdw.tms.model.resp;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.model.resp
 * @ClassName: CdHedgingEfficiencyResp
 * @Description: 对冲效率
 * @Author: Maureen.Rong
 * @CreateDate: 2020/11/3 12:02
 * @UpdateDate: 2020/11/3 12:02
 * @Version: 1.0
 */
@Data
@ApiModel("对冲效率")
public class CdHedgingEfficiencyResp {
    //序号
    @ApiModelProperty(value = "序号")
    private Integer id;

    //合约名称
    @ApiModelProperty(value = "合约名称")
    private String name;

    //现货盈亏
    @ApiModelProperty(value = "现货盈亏")
    private BigDecimal promptGoodsPL;

    //期货盈亏
    @ApiModelProperty(value = "期货盈亏")
    private BigDecimal futuresPl;

    //总盈亏
    @ApiModelProperty(value = "总盈亏")
    private BigDecimal totalPl;
    //总盈亏率
    @ApiModelProperty(value = "总盈亏率")
    private String totalPlRatio;

    //对冲风险效率
    @ApiModelProperty(value = "对冲风险效率")
    private String riskEfficiency;

    //对冲风险比率
    @ApiModelProperty(value = "对冲风险比率")
    private String riskRatio;

}
