package com.msdw.tms.model.resp;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.model.resp
 * @ClassName: CdHoldPositionInfoResp
 * @Description: 外汇期货持仓信息
 * @Author: Maureen.Rong
 * @CreateDate: 2020/10/28 11:34
 * @UpdateDate: 2020/10/28 11:34
 * @Version: 1.0
 */
@ApiModel(value = "返回信息", description = "外汇期货持仓信息")
@Data
public class CdHoldPositionInfoResp {
    @ApiModelProperty(value = "序号", required = false)
    private Integer id;

    @ApiModelProperty(value = "用户id")
    private Integer userId;


    @ApiModelProperty(value = "交易方向(0空头卖,1多头买)")
    private String tradingDirection;


    @ApiModelProperty(value = "均价/现价")
    private BigDecimal entrustPrice;

    @ApiModelProperty(value = "(持仓可用)委托数量")
    private Integer entrustNumber;

    @ApiModelProperty(value = "持仓状态(0.开仓 1.平仓)")
    private String status;


    @ApiModelProperty(value = "开仓时间")
    private String createTime;

    @ApiModelProperty(value = "平仓时间")
    private String updateTime;

    @ApiModelProperty(value = "最后交易日")
    private String tradeTime;


    @ApiModelProperty(value = "合约名称")
    private String name;

    @ApiModelProperty(value = "合约代码")
    private String ename;


    @ApiModelProperty(value = "浮动盈亏")
    private BigDecimal floatingPl;

    @ApiModelProperty(value = "保证金")
    private BigDecimal preFreezingMargin;


}
