package com.msdw.tms.model.resp;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @ProjectName: tms
 * @Package: com.msdw.tms.model.resp
 * @ClassName: CdTransferWarehouseDetailResp
 * @Description: 调仓展示详情
 * @Author: Maureen.Rong
 * @CreateDate: 2020/11/2 15:40
 * @UpdateDate: 2020/11/2 15:40
 * @Version: 1.0
 */
@Data
@ApiModel("调仓前详情展示")
public class CdTransferWarehouseDetailResp {

    @ApiModelProperty(value = "主键", required = false)
    @TableId(type = IdType.AUTO)
    private Integer id;


    @ApiModelProperty(value = "合约表主键")
    private Integer pid;

    @ApiModelProperty(value = "交易方向(0空头,1多头)")
    private Integer tradingDirection;

    @ApiModelProperty(value = "委托价")
    private BigDecimal newestPrice;

    @ApiModelProperty(value = "名称")
    private transient String name;

    @ApiModelProperty(value = "代码")
    private transient String ename;

    @ApiModelProperty(value = "当前最新价")
    private transient BigDecimal lastPrice;

    @ApiModelProperty(value = "涨跌幅")
    private transient String u;

    @ApiModelProperty(value = "昨收")
    private transient BigDecimal dayUp;

    @ApiModelProperty(value = "买卖方向为开仓时候:可交易数量为Python表的持仓总量")
    private transient BigDecimal tradableQuantityByBuy;

    @ApiModelProperty(value = "买卖方向为平仓时候:可交易数量为自己的持仓总量")
    private transient BigDecimal tradableQuantityBySell;

    @ApiModelProperty(value = "当前期权账户可用资金")
    private transient BigDecimal availableFunds;


    @ApiModelProperty(value = "涨跌额")
    private BigDecimal udPrice;

    @ApiModelProperty(value = "买入价")
    private BigDecimal buyPrice;

    @ApiModelProperty(value = "卖出价")
    private BigDecimal cellPrice;

    @ApiModelProperty(value = "买量")
    private Integer buy;

    @ApiModelProperty(value = "卖量")
    private Integer cell;

    @ApiModelProperty(value = "总量")
    private BigDecimal suoyou;

    @ApiModelProperty(value = "持仓量")
    private String hava;


}
