package com.msdw.tms.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.msdw.tms.common.utils.R;
import com.msdw.tms.entity.CdFuturesConfigureEntity;
import com.msdw.tms.entity.vo.CdFuturesConfigureEntityVo;
import com.msdw.tms.model.resp.CdAfterHedgingResp;
import com.msdw.tms.model.resp.CdBeforeHedgingResp;
import com.msdw.tms.model.resp.CdHoldPositionInfoResp;
import com.msdw.tms.model.resp.CdTransferWarehouseDetailResp;
import org.springframework.stereotype.Service;

/**
 * @描述：期货资产头寸配置 service接口
 * @作者: Rong
 * @日期: 2020-10-10
 */
@Service
public interface CdFuturesConfigureService extends IService<CdFuturesConfigureEntity> {
    //开仓
    R openPosition(CdFuturesConfigureEntity entity);

    //平仓
    R buyIn(int id, String date, Integer userId);

    //调仓详情展示
    CdTransferWarehouseDetailResp transferWarehouseByDetail(int id);


    //外汇期货持仓情况
    CdHoldPositionInfoResp myPosition(int id);

    //外汇期货平仓绩效
    CdFuturesConfigureEntityVo buyInAchievements(int id, Integer userId);

    //外汇现货盈亏
    CdBeforeHedgingResp beforeHedging(int userId);


    //对冲后损益情况
    CdAfterHedgingResp afterHedging(int userId);

    //根据id删除开仓信息
    boolean delOpenPosition(int id,int userId);


}