package com.msdw.tms.service.impl;

import com.aliyun.oss.OSSClient;
import com.msdw.tms.common.utils.AliyunOssUtil;
import com.msdw.tms.common.utils.FilesResult;
import com.msdw.tms.config.AliyunOssConfig;
import com.msdw.tms.service.AliyunOssService;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * 阿里云OSSUtil
 */
@Service
public class AliyunOssServiceImpl implements AliyunOssService {

    @Resource
    AliyunOssConfig config;

    @Resource
    BeanFactory beanFactory;

    /**
     * 上传文件
     *
     * @param file 上传文件
     */
    public FilesResult uploadFiles(MultipartFile file) throws IOException {
        OSSClient client = beanFactory.getBean(OSSClient.class);
        return AliyunOssUtil.uploadFiles(file, client, config);
    }

    /**
     * 下载文件
     *
     * @param objectName 本地路径
     */
    public void downloadFiles(HttpServletResponse response, String objectName) throws IOException {
        OSSClient client = beanFactory.getBean(OSSClient.class);
        AliyunOssUtil.downloadFiles(response, client, config, objectName);
    }

    /**
     * 根据文件路径+文件名称，删除该文件
     *
     */
    public void deleteFile(String filename) {
        OSSClient client = beanFactory.getBean(OSSClient.class);
        AliyunOssUtil.deleteFile(client, config.getBucketName(), filename);
    }
}
