package com.msdw.tms.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.msdw.tms.common.utils.R;
import com.msdw.tms.dao.CdCacheDao;
import com.msdw.tms.entity.CdCacheEntity;
import com.msdw.tms.service.CdCacheService;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * @描述：步骤缓存记录表 服务类
 * @作者: Rong
 * @日期: 2020-10-21
 */
@Service("cdCacheService")
public class CdCacheServiceImpl extends ServiceImpl<CdCacheDao, CdCacheEntity> implements CdCacheService {

    @Resource
    private CdCacheDao dao;

    @Resource
    public RedisTemplate<String, String> template;

    /**
     * 步骤保存
     *
     * @param userId
     * @param stepNumber
     * @param json
     * @return
     */
    @Override
    public R cache(Integer userId, Integer stepNumber, JSONObject json) {
        //先查询用户有没有存在记录
        QueryWrapper<CdCacheEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("user_id", userId);
        CdCacheEntity cache = baseMapper.selectOne(queryWrapper);

        System.out.println("打印:" + "stepNumber:" + stepNumber + "\tjson:");

        if (cache == null) {
            //表示第一次进入
            CdCacheEntity entity = new CdCacheEntity();
            entity.setUserId(userId);
            entity.setStep1(json.toJSONString());
            entity.setStepNumber(1);
            int flag = baseMapper.insert(entity);
            if (flag == 1) {
                return R.ok();
            }
        }
        //如果存在记录 则根据相应的步骤数 填入相应的Json字符串
        UpdateWrapper<CdCacheEntity> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("user_id", userId);
        updateWrapper.set("step_number", stepNumber);
        updateWrapper.set("step" + stepNumber, json.toJSONString());
        dao.update(null, updateWrapper);

        return R.ok();
    }
}



