package com.msdw.tms.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.msdw.tms.dao.CdUserAssetsDao;
import com.msdw.tms.entity.CdUserAssetsEntity;
import com.msdw.tms.service.CdUserAssetsService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * @描述：用户银行账户 服务类
 * @作者: Rong
 * @日期: 2020-10-10
 */
@Service("CdUserAssetsService")
public class CdUserAssetsServiceImpl extends ServiceImpl<CdUserAssetsDao, CdUserAssetsEntity> implements CdUserAssetsService {

    @Resource
    private CdUserAssetsDao dao;


    //插入银行信息账户信息以及期权账户信息
    @Override
    public int addInfo(CdUserAssetsEntity userAssetsEntity) {
        try {
            int code = baseMapper.insert(userAssetsEntity);
            return code;
        } catch (Exception e) {
            e.printStackTrace();
            return -1;
        }
    }

    @Override
    public CdUserAssetsEntity userAssetsByUerId(long userId) {
        try {
            QueryWrapper<CdUserAssetsEntity> queryWrapper = new QueryWrapper<CdUserAssetsEntity>();
            queryWrapper.eq("user_id", userId);
            CdUserAssetsEntity optionAccount = optionAccount = baseMapper.selectOne(queryWrapper);
            return optionAccount;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public int modify(long userId) {
        try {
            QueryWrapper<CdUserAssetsEntity> queryWrapper = new QueryWrapper<CdUserAssetsEntity>();
            queryWrapper.eq("user_id", userId);
            CdUserAssetsEntity userAssets = new CdUserAssetsEntity();
            userAssets.setUserId(userId);
            int update = baseMapper.update(userAssets, queryWrapper);
            return update;
        } catch (Exception e) {
            e.printStackTrace();
            return -1;
        }
    }
}



