package com.msdw.tms.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.msdw.tms.dao.CdUserOptionAccountDao;
import com.msdw.tms.entity.CdUserOptionAccountEntity;
import com.msdw.tms.service.CdUserOptionAccountService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;

/**
 * @描述：期货期权账户 服务类
 * @作者: Rong
 * @日期: 2020-10-10
 */
@Service("cdUserOptionAccountService")
public class CdUserOptionAccountServiceImpl extends ServiceImpl<CdUserOptionAccountDao, CdUserOptionAccountEntity> implements CdUserOptionAccountService {

    @Resource
    private CdUserOptionAccountDao dao;

    @Override
    public int addInfoByOptionAccount(CdUserOptionAccountEntity userOptionAccount) {


        try {
            int code = baseMapper.insert(userOptionAccount);
            return code;
        } catch (Exception e) {
            e.printStackTrace();
            return -1;
        }
    }

    //查看期权账户信息
    @Override
    public CdUserOptionAccountEntity optionAccountByUerId(long userId) {
        try {
            QueryWrapper<CdUserOptionAccountEntity> queryWrapper = new QueryWrapper<CdUserOptionAccountEntity>();
            queryWrapper.eq("user_id", userId);
            CdUserOptionAccountEntity optionAccount = baseMapper.selectOne(queryWrapper);
            //总资金 = 资产市值 + 占用保证金 + 冻结资金 + 可用资金
            BigDecimal totalAssets = optionAccount.getDepositBalance().add(optionAccount.getDepositBalance().add(optionAccount.getBalance().add(optionAccount.getForzenBalance())));
            optionAccount.setTotalAssets(totalAssets);
            return optionAccount;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }


    }

    @Override
    public int modify(long userId) {
        try {
            QueryWrapper<CdUserOptionAccountEntity> queryWrapper = new QueryWrapper<CdUserOptionAccountEntity>();
            queryWrapper.eq("user_id", userId);
            CdUserOptionAccountEntity userAssets = new CdUserOptionAccountEntity();
            userAssets.setUserId(userId);
            int update = baseMapper.update(userAssets, queryWrapper);
            return update;
        } catch (Exception e) {
            e.printStackTrace();
            return -1;
        }
    }
}



