package com.msdw.tms.service.impl;

import cn.afterturn.easypoi.excel.ExcelExportUtil;
import cn.afterturn.easypoi.excel.entity.ExportParams;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.msdw.tms.common.utils.PageUtils;
import com.msdw.tms.common.utils.R;
import com.msdw.tms.common.utils.py.PyUtil;
import com.msdw.tms.dao.QhscGangjiaosuoDao;
import com.msdw.tms.dao.WhscRenminbipinzhongDao;
import com.msdw.tms.entity.QhscGangjiaosuoEntity;
import com.msdw.tms.entity.WhscRenminbipinzhongEntity;
import com.msdw.tms.entity.vo.CdCreatePhotoVo;
import com.msdw.tms.service.WhscRenminbipinzhongService;
import org.apache.commons.lang.StringUtils;
import org.apache.poi.ss.usermodel.Workbook;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.net.URLEncoder;
import java.util.Iterator;
import java.util.List;

/**
 * @描述：外汇市场人民币品种 服务类
 * @作者: Rong
 * @日期: 2020-09-28
 */
//@Slf4j
@Service("whscRenminbipinzhongService")
@DS("pydb")
public class WhscRenminbipinzhongServiceImpl extends ServiceImpl<WhscRenminbipinzhongDao, WhscRenminbipinzhongEntity> implements WhscRenminbipinzhongService {

    @Resource
    public RedisTemplate<String, String> template;

    @Resource
    public QhscGangjiaosuoDao qhscGangjiaosuoDao;

    //导出Excel
    @Override
    public R exportProjectRecord(HttpServletResponse response, String name, String startTime, String endTime) throws Exception {


        try {
            String strSql = " ";
            int i = 0;//定义是否第一次循环
            QueryWrapper<WhscRenminbipinzhongEntity> queryWrapper = new QueryWrapper<>();
            //查询币种名称
            List<QhscGangjiaosuoEntity> getRmb = qhscGangjiaosuoDao.getName();
            Iterator<QhscGangjiaosuoEntity> it = getRmb.iterator();


            if (!StringUtils.isEmpty(name)) {
                queryWrapper.like("name", name + "人民币中间价");
            }

            if (!StringUtils.isEmpty(startTime) && !StringUtils.isEmpty(endTime)) {
                queryWrapper.ge("date", startTime).le("date", endTime);
            }

            //如果币种 时间都为空导出全部
            if (StringUtils.isEmpty(name) && StringUtils.isEmpty(startTime) && StringUtils.isEmpty(endTime)) {
                //int i = 0;//定义是否第一次循环
                while (it.hasNext()) {
                    String x = it.next().getCurrency();
                    if (x.equals("人民币")) {
                        it.remove();
                        continue;
                    }

                    if (i == 0) {
                        strSql += " WHERE ( name like concat('" + x + "%人民币中间价')";
                        i++;
                    }

                    //queryWrapper.like("name", "中间价");
                    strSql += " or name like concat('" + x + "%人民币中间价')";
                    //queryWrapper.last(" and name like concat('%"+x+"中间价')");
                }
                //strSql += ")";
                queryWrapper.last(strSql);
                //参数一是当前页，参数二是每页个数
            }

            //如果不选择币种时候默认查询全部的
            if (StringUtils.isEmpty(name)) {

                //int i = 0;//定义是否第一次循环
                while (it.hasNext()) {
                    String x = it.next().getCurrency();
                    if (x.equals("人民币")) {
                        it.remove();
                        continue;
                    }

                    if (i == 0) {
                        strSql += " and ( name like concat('" + x + "%人民币中间价')";
                        i++;
                    }

                    //queryWrapper.like("name", "中间价");
                    strSql += " or name like concat('" + x + "%人民币中间价')";
                    //queryWrapper.last(" and name like concat('%"+x+"中间价')");
                }
                strSql += ")";
                queryWrapper.last(strSql);
                //参数一是当前页，参数二是每页个数
            }


            //list
            List<WhscRenminbipinzhongEntity> list = this.list(queryWrapper);
            if (list.size() == 0) {
                return R.ok("暂无此数据,换个时间试试吧");
            }


            // 告诉浏览器用什么软件可以打开此文件
            response.setHeader("content-Type", "application/vnd.ms-excel");
            // 下载文件的默认名称
            response.setHeader("Content-Disposition", "attachment;filename=" + URLEncoder.encode("汇率历史行情数据", "UTF-8") + ".xls");
            //编码
            response.setCharacterEncoding("UTF-8");
            Workbook workbook = ExcelExportUtil.exportExcel(new ExportParams(), WhscRenminbipinzhongEntity.class, list);
            workbook.write(response.getOutputStream());
            return null;
        } catch (IOException e) {
            e.printStackTrace();
            return R.error("出现异常:" + e.getMessage());

        }


    }


    /**
     * 步骤二：当日外汇行情
     *
     * @param pageNum
     * @param pageSize
     * @param name
     * @param date
     * @return
     */
    @Override
    public PageUtils queryPageByRecode(Integer pageNum, Integer pageSize, String name, String date, Integer userId) {

        if (date != null) {
            template.opsForValue().set("date:userId_" + userId, date);
        }

        //分页对象
        QueryWrapper<WhscRenminbipinzhongEntity> queryWrapper = new QueryWrapper<WhscRenminbipinzhongEntity>();
        //查询币种名称
        List<QhscGangjiaosuoEntity> getRmb = qhscGangjiaosuoDao.getName();
        Iterator<QhscGangjiaosuoEntity> it = getRmb.iterator();
        //判断条件值是否为空,如果不为空,拼接条件
        /*if (!StringUtils.isEmpty(date)) {
            queryWrapper.eq("date", date);
        }
        if (!StringUtils.isEmpty(name)) {
            queryWrapper.like("name", name + "人民币中间价");
        }*/


        if (!StringUtils.isEmpty(name) && !StringUtils.isEmpty(date)) {
            queryWrapper.eq("date", date);
            queryWrapper.like("name", name + "人民币中间价");
        }
        String strSql = " ";
        int i = 0;//定义是否第一次循环

        //日期不为空 名称为空时
        if (!StringUtils.isEmpty(date) && StringUtils.isEmpty(name)) {
            strSql = "where 1 = 1";

            while (it.hasNext()) {
                String x = it.next().getCurrency();
                if (x.equals("人民币")) {
                    it.remove();
                    continue;
                }

                if (i == 0) {
                    strSql += " and  name like concat('%" + x + "人民币中间价%') and DATE_FORMAT(date, '%Y-%m-%d') = '" + date + "'";


                    i++;
                } else if (i == 1) {
                    strSql += " or name like concat('%" + x + "人民币中间价%') and DATE_FORMAT(date, '%Y-%m-%d') = '" + date + "'";
                }


            }
            //strSql += ")";
            queryWrapper.last(strSql);
            //参数一是当前页，参数二是每页个数
        }

        //名称为空时
        if (StringUtils.isEmpty(name) && StringUtils.isEmpty(date)) {
            strSql = "where 1=1";
            //查询币种名称
            //String strSql = " ";
            //int i = 0;//定义是否第一次循环
            while (it.hasNext()) {
                String x = it.next().getCurrency();
                if (x.equals("人民币")) {
                    it.remove();
                    continue;
                }

                if (i == 0) {
                    strSql += " and  name like concat('" + x + "%人民币中间价')";
                    i++;
                }

                //queryWrapper.like("name", "中间价");
                strSql += " or name like concat('" + x + "%人民币中间价')";
                //queryWrapper.last(" and name like concat('%"+x+"中间价')");
            }
            //strSql += ")";
            queryWrapper.last(strSql);
            //参数一是当前页，参数二是每页个数
        }

        Page<WhscRenminbipinzhongEntity> page = new Page<WhscRenminbipinzhongEntity>(pageNum, pageSize);
        page = this.page(page, queryWrapper);
        return new PageUtils(page);
    }

    /**
     * 根据选择的模拟法传值获取相应数据
     *
     * @param name
     * @param startTime         样本区间开始时间
     * @param endTime           样本区间结束时间
     * @param confidenceLevel   置信水平
     * @param validity          持有效
     * @param type              类型(0.正态VaR 1.历史模拟法 2.蒙特卡洛模拟法)
     * @param experimentsNumber 实验次数
     * @return
     */
    @Override
    public R getInfobyId(String name, String startTime, String endTime, String confidenceLevel, String validity, Integer type, String experimentsNumber) {

        try {

            if (startTime.equals(endTime)) {
                return R.error("样本区间时间不能为同一天!");
            }

            QueryWrapper<WhscRenminbipinzhongEntity> wrapper = new QueryWrapper<WhscRenminbipinzhongEntity>();
            wrapper.like("name", name);
            wrapper.last("limit 0,1");

            //获取代码
            String e_name = baseMapper.selectOne(wrapper).geteName();


            //根据代码样本日期查询
            QueryWrapper<WhscRenminbipinzhongEntity> queryWrapper = new QueryWrapper<WhscRenminbipinzhongEntity>();
            queryWrapper.eq("e_name", e_name);
            if (startTime != null && endTime != null) {
                queryWrapper.ge("date", startTime).le("date", endTime);
            }
            List<WhscRenminbipinzhongEntity> rmb = baseMapper.selectList(queryWrapper);

            if (rmb.size() == 0) {
                return R.error("暂时没有该区间的数据!");
            } else if (rmb.size() < 2) {
                return R.error("暂时没有该区间的数据!");
            } else {

                String code = "";
                for (WhscRenminbipinzhongEntity e : rmb) {

                    String s = String.valueOf(e.getLastPrice());
                    code += s + ",";
                }
                code = code.substring(0, code.length() - 1);

                CdCreatePhotoVo vo = new CdCreatePhotoVo();

                /**
                 *
                 * getVar  置信水平（小数） 天数 列表
                 * getVarByHistory 置信水平（小数） 天数 列表
                 * photo  次数  天数  列表
                 */
                //(0.正态VaR 1.历史模拟法 2.蒙特卡洛模拟法)
                switch (type) {
                    case 0:
                        String getVar = PyUtil.getVarCode(PyUtil.path, PyUtil.pyPathByVar, confidenceLevel, validity, code);
                        vo.setVar(getVar);
                        return R.ok().put("data", vo);
                    case 1:
                        String getVarByHistory = PyUtil.getCodeByHis(PyUtil.path, PyUtil.historyPath, confidenceLevel, validity, code);
                        vo.setVar(getVarByHistory);
                        return R.ok().put("data", vo);

                    case 2:

                        String buffer = PyUtil.getCodeByPhoto(PyUtil.path, PyUtil.pyPathByPhoto, experimentsNumber, validity, code);
                        if (buffer.length() > 0) {

                            String[] split = buffer.split(",");
                            String p1 = split[0];
                            String p2 = split[1];
                            vo.setPhoto_url1(p1);
                            vo.setPhoto_url2(p2);
                            return R.ok().put("data", vo);
                        }
                    default:
                        return R.error("参数异常");
                }
            }


        } catch (IOException e) {
            e.printStackTrace();
            return R.error(e.getMessage());
        }
    }

    /**
     * 汇率类型
     *
     * @return
     */
    @Override
    public List<WhscRenminbipinzhongEntity> getExchangeRate() {
        return baseMapper.getExchangeRate();
    }


}



