/*
Navicat MySQL Data Transfer

Source Server         : localhost
Source Server Version : 80020
Source Host           : localhost:3306
Source Database       : msdw_tms

Target Server Type    : MYSQL
Target Server Version : 80020
File Encoding         : 65001

Date: 2020-08-26 18:02:57
*/

SET FOREIGN_KEY_CHECKS=0;

-- ----------------------------
-- Table structure for tms_evaluation_rules
-- ----------------------------
DROP TABLE IF EXISTS `tms_evaluation_rules`;
CREATE TABLE `tms_evaluation_rules` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT '主键',
  `evaluation_type` int DEFAULT NULL COMMENT '测评类型：1：随机类型，0：自定义类型',
  `duration` int DEFAULT NULL COMMENT '测评时长，单位：分钟',
  `question_num` int DEFAULT NULL COMMENT '测评总题数',
  `single_num` int DEFAULT NULL COMMENT '单选题数',
  `is_single_enable` int DEFAULT '1' COMMENT '只在类型为自定义类型时才启用：1：启用，0：不启用，默认1启用',
  `multiple_num` int DEFAULT NULL COMMENT '多选题数',
  `is_multiple_enable` int DEFAULT '1' COMMENT '只在类型为自定义类型时才启用：1：启用，0：不启用，默认1启用',
  `judgment_num` int DEFAULT NULL COMMENT '判断题数',
  `is_judgment_enable` int DEFAULT '1' COMMENT '只在类型为自定义类型时才启用：1：启用，0：不启用，默认1启用',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci COMMENT='测评规则信息记录，只记录一条信息';

-- ----------------------------
-- Records of tms_evaluation_rules
-- ----------------------------
INSERT INTO `tms_evaluation_rules` VALUES ('1', '1', '10', '0', '0', '1', '0', '1', '0', '1');

-- ----------------------------
-- Table structure for tms_questions
-- ----------------------------
DROP TABLE IF EXISTS `tms_questions`;
CREATE TABLE `tms_questions` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `question_type` int DEFAULT NULL COMMENT '题型：1、单选题，2、多选题，3、判断题',
  `question_stem` text COMMENT '题干信息',
  `option_a` text COMMENT 'A选项内容',
  `option_b` text COMMENT 'B选项内容',
  `option_c` text COMMENT 'C选项内容',
  `option_d` text COMMENT 'D选项内容',
  `option_e` text COMMENT 'E选项内容',
  `option_f` text COMMENT 'F选项内容',
  `answer` varchar(32) DEFAULT NULL COMMENT '正确答案',
  `answer_analysis` text COMMENT '答案解析',
  `is_enable` int DEFAULT '1' COMMENT '是否禁用：1：启用，0：禁用，默认是1启用',
  `is_del` int DEFAULT '0' COMMENT '是否删除：0未删除，1删除，默认0未删除',
  `create_user` varchar(32) DEFAULT NULL COMMENT '创建人',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `modify_user` varchar(32) DEFAULT NULL COMMENT '修改人',
  `modify_time` datetime DEFAULT NULL COMMENT '修改时间，用于排序，创建时，修改时间等于创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=53 DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci COMMENT='记录试题信息';

-- ----------------------------
-- Table structure for tms_xlsx_template
-- ----------------------------
DROP TABLE IF EXISTS `tms_xlsx_template`;
CREATE TABLE `tms_xlsx_template` (
  `id` int NOT NULL AUTO_INCREMENT COMMENT '主键',
  `file_name` varchar(300) DEFAULT NULL COMMENT '文件名',
  `file_url` varchar(500) DEFAULT NULL COMMENT '文件全路径',
  `status` int DEFAULT NULL COMMENT '状态',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci COMMENT='模板文件信息记录';

-- ----------------------------
-- Records of tms_xlsx_template
-- ----------------------------
INSERT INTO `tms_xlsx_template` VALUES ('1', 'xlsx/20200826/1598430904075.xlsx', 'http://liuwanr.oss-cn-shenzhen.aliyuncs.com/xlsx/20200826/1598430904075.xlsx', null);

-- ----------------------------
-- Table structure for tms_evaluation_question
-- ----------------------------
DROP TABLE IF EXISTS `tms_evaluation_question`;
CREATE TABLE `tms_evaluation_question` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `evaluation_record_id` int(11) DEFAULT NULL COMMENT '测评记录表id',
  `question_id` int(11) DEFAULT NULL COMMENT '试题id',
  `question_sort_no` int(11) DEFAULT NULL COMMENT '试题顺序号',
  `question_status` int(11) DEFAULT '0' COMMENT '试题状态：是否已被作过:1、已作/0、未作',
  `user_answer` varchar(32) DEFAULT NULL COMMENT '用户填写的答案',
  `is_ture` int(11) DEFAULT '0' COMMENT '是否正确：1、正确/0、错误',
  `question_points` int(11) DEFAULT NULL COMMENT '试题分值',
  `question_score` int(11) DEFAULT NULL COMMENT '试题得分',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8 COMMENT='测评试题表，记录每次测评的试题，与测评记录表相关联';

-- ----------------------------
-- Table structure for tms_evaluation_record
-- ----------------------------
DROP TABLE IF EXISTS `tms_evaluation_record`;
CREATE TABLE `tms_evaluation_record` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `user_id` int(11) DEFAULT NULL COMMENT '当前测评的用户的id',
  `current_question_sort_no` int(11) DEFAULT '1' COMMENT '记录当前做到第几题，用于刷新页面以后保持在当前题目，默认开始时是第一题',
  `total_question_num` int(11) DEFAULT NULL COMMENT '总题目数量',
  `evaluation_status` int(11) DEFAULT '0' COMMENT '当前测评状态：1：已提交/0：未提交',
  `start_time` datetime DEFAULT NULL COMMENT '开始时间',
  `submit_time` datetime DEFAULT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='记录用户测评信息';


