package com.msdw.tms;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.msdw.tms.entity.request.QuestionsImportRequest;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.data.redis.core.ValueOperations;

import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.concurrent.TimeUnit;
import java.util.function.Function;
import java.util.stream.Collectors;


@SpringBootTest
class TmsApplicationTests {

    @Test
    void contextLoads() throws UnsupportedEncodingException {

        System.out.println(URLDecoder.decode("%E8%AF%95%E9%A2%98%E8%A1%A8", "UTF-8"));

        //printMsg(1, 2, 3, "哈哈哈");
//          ------------------------------------------------------------------------------------------

//        QuestionsVO questionsVO = new QuestionsVO();
//
//        QuestionsEntity questionsEntity = new QuestionsEntity();
//
//        questionsEntity.setId(1);
//        questionsEntity.setQuestionType("单选题");
//        questionsEntity.setQuestionStem("adfasdfasdfasd");
//        questionsEntity.setQuestionTypeNo(1);
//        questionsEntity.setIsEnable(1);
//        questionsEntity.setIsDel(1);
//        questionsEntity.setCreateUser("eqweq");
//        questionsEntity.setModifyUser("sadsa");
//        questionsEntity.setCreateTime(new Date());
//        questionsEntity.setModifyTime(new Date());
//        questionsEntity.setAnswer("asdasdasdsd");
//        questionsEntity.setAnswerAnalysis("qeqwewqeqweeqweqwe");
//        questionsEntity.setOptionA("dasdsada");
//        questionsEntity.setOptionB("asdasd");
//        questionsEntity.setOptionC("dasdsada");
//        questionsEntity.setOptionD("dasdsada");
//        questionsEntity.setOptionE("dasdsada");
//        questionsEntity.setOptionF("dasdsada");
//        questionsEntity.setSubjects("sadasd");
//
//        BeanUtils.copyProperties(questionsEntity, questionsVO);
//
//        System.out.println(questionsVO.toString());

//          ------------------------------------------------------------------------------------------

//        Date date = new Date();
//        Instant instant = date.toInstant();
//        ZoneId zoneId = ZoneId.systemDefault();
//
//        LocalDateTime localDateTime = instant.atZone(zoneId).toLocalDateTime();
//        System.out.println("Date = " + date);
//        System.out.println("LocalDateTime = " + localDateTime);
//        String DateNow = localDateTime.format(DateTimeFormatter.ofPattern("yyyy/MM/dd HH:mm:ss")); // 当前日期和时间
//        // String DateNow = LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy/MM/dd HH:mm:ss")); // 当前日期和时间
//        System.out.println(DateNow);
    }

    <T> void printMsg(T... args) {
        for (T t : args) {
            System.out.println("t is " + t);
        }
    }

    /**
     * 泛型方法的基本介绍
     *
     * @param tClass 传入的泛型实参
     * @return T 返回值为T类型
     * 说明：
     * 1）public 与 返回值中间<T>非常重要，可以理解为声明此方法为泛型方法。
     * 2）只有声明了<T>的方法才是泛型方法，泛型类中的使用了泛型的成员方法并不是泛型方法。
     * 3）<T>表明该方法将使用泛型类型T，此时才可以在方法中使用泛型类型T。
     * 4）与泛型类的定义一样，此处T可以随便写为任意标识，常见的如T、E、K、V等形式的参数常用于表示泛型。
     */
    public <T> T genericMethod(Class<T> tClass) throws InstantiationException,
            IllegalAccessException {
        T instance = tClass.newInstance();
        return instance;
    }

    public <T, K> K t2(T t, K k) {
        k = (K) "haha";
        return k;
    }

    private String formatDateTime(long mss) {
        String DateTimes = null;
        long days = mss / (60 * 60 * 24);
        long hours = (mss % (60 * 60 * 24)) / (60 * 60);
        long minutes = (mss % (60 * 60)) / 60;
        long seconds = mss % 60;
        if (days > 0) {
            DateTimes = days + "天" + hours + "小时" + minutes + "分钟"
                    + seconds + "秒";
        } else if (hours > 0) {
            DateTimes = hours + "小时" + minutes + "分钟"
                    + seconds + "秒";
        } else if (minutes > 0) {
            DateTimes = minutes + "分钟"
                    + seconds + "秒";
        } else {
            DateTimes = seconds + "秒";
        }

        return DateTimes;
    }

    private String formatDateTime2(long mss) {
        String DateTimes;
        long hours = (mss % (60 * 24)) / (60);
        long minutes = (mss % (60));
        //long seconds = mss % 60;
        if (hours > 0) {
            if (hours < 10) {
                DateTimes = "0" + hours + ":" + minutes;
            } else {
                DateTimes = hours + ":" + minutes;
            }
        } else {
            DateTimes = "00:" + minutes;
        }

        return DateTimes;
    }

    @Test
    void t2() {
        long mss = 150;
        String ss = formatDateTime2(mss);
        System.out.println(ss);
    }

    /**
     * 获取精确到秒的时间戳
     *
     * @param date
     * @return
     */
    private int getSecondTimestampTwo(Date date) {
        if (null == date) {
            return 0;
        }
        String timestamp = String.valueOf(date.getTime() / 1000 / 60);
        return Integer.valueOf(timestamp);
    }

    @Test
    void t3() {
        String s = handleTime(new Date());
        System.out.println("ssss" + s);

        int secondTimestampTwo = getSecondTimestampTwo(new Date());
        System.out.println(secondTimestampTwo);
        long l = System.currentTimeMillis();
        System.out.println("----" + new Date().getTime());
        System.out.println("====" + System.currentTimeMillis());

        // System.currentTimeMillis() / (long)1000 / (long)60;
    }

    @Test
    void t4() throws ParseException {
        Date date = getDate("2020-08-26 09:13:51");

        int secondTimestampTwo = getSecondTimestampTwo(date);

        int secondTimestampTwo1 = getSecondTimestampTwo(new Date());

        int i = secondTimestampTwo1 - secondTimestampTwo;

        System.out.println(i);
        // System.currentTimeMillis() / (long)1000 / (long)60;
    }

    //处理时间格式
    private String handleTime(Date date) {
        Instant instant = date.toInstant();
        ZoneId zoneId = ZoneId.systemDefault();
        LocalDateTime localDateTime = instant.atZone(zoneId).toLocalDateTime();
        return localDateTime.format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")); // 当前日期和时间
    }

    private Date getDate(String dateStr) throws ParseException {
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");//注意月份是MM
        Date date = simpleDateFormat.parse(dateStr);
        System.out.println(date);   //Mon Sep 02 00:00:00 CST 2019
        System.out.println(simpleDateFormat.format(date));  //2019-09-02
        return date;
    }


    @Autowired
    StringRedisTemplate stringRedisTemplate;


    @Test
    void t5() throws ParseException {

        ValueOperations<String, String> ops = stringRedisTemplate.opsForValue();

        ops.set("aaa", "sss", 30, TimeUnit.SECONDS);
    }

    @Test
    void t6() throws ParseException {

        int se = 130 * 60;

        String s = DateUtil.secondToTime(se);

        System.out.println(s);
    }

    @Test
    void t7() throws ParseException {

        String f = "hahdhfasdf.xlsx";

        System.out.println(f.substring(f.lastIndexOf(".")));

    }

    @Test
    void t8() {

        List<String> list = new ArrayList<>();
        list.add("a");
        list.add("b");
        list.add("c");
        list.add("d");
        list.add("b");
        list.add("c");
        list.add("a");
        list.add("a");
        list.add("a");

        System.out.println("\n例子1 - 计算'a'出现的次数");
        System.out.println("a : " + Collections.frequency(list, "a"));

        System.out.println("\n例子2 - 计算所有对象出现的次数");
        Set<String> uniqueSet = new HashSet<>(list);
        for (String temp : uniqueSet) {
            System.out.println(temp + ": " + Collections.frequency(list, temp));
        }

        System.out.println("\n例子3 -用Map来计算对象出现的次数");
        Map<String, Integer> map = new HashMap<>();

        for (String temp : list) {
            Integer count = map.get(temp);
            map.put(temp, (count == null) ? 1 : count + 1);
        }
        printMap(map);

        System.out.println("\nMap排序-以key排序");
        Map<String, Integer> treeMap = new TreeMap<>(map);
        printMap(treeMap);

    }

    static void printMap(Map<String, Integer> map) {
        for (Map.Entry<String, Integer> entry : map.entrySet()) {
            System.out.println("Key-value : " + entry.getKey() + "- "
                    + entry.getValue());
        }
    }


    @Test
    void t9() throws Exception {

        List<UserTest> list = new ArrayList<>();
        list.add(new UserTest(1, "张三", "男", "深圳", "123456"));
        list.add(new UserTest(2, "李四", "男", "深圳", "123456"));
        list.add(new UserTest(3, "张三", "男", "杭州", "123456"));
        list.add(new UserTest(4, "张三", "男", "深圳", "123456"));
        list.add(new UserTest(5, "王五", "男", "深圳", "123456"));
        list.add(new UserTest(6, "张三", "男", "深圳", "123456"));
        list.add(new UserTest(7, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(8, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(9, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(10, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(11, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(12, "张三", "男", "菲律宾", "123456"));
        list.add(new UserTest(13, "张三", "男", "深圳", "123456"));
        list.add(new UserTest(14, "张三", "男", "马来西亚", "123456"));


        List<String> errorMsg = new ArrayList<>();

        ArrayList<UserTest> collect = list.stream()
                .collect(Collectors.collectingAndThen(// 去重收集
                        Collectors.toCollection(() ->
                                new TreeSet<>(Comparator.comparing(UserTest::toString))),
                        ArrayList::new
                ));

        for (UserTest userTest : collect) {

            System.out.println(userTest.getIndex() + "-----" + userTest.toString());
        }

        System.out.println("----------------------------");

        List<UserTest> userTests = removeRepeatFactor3(collect, list);

        for (UserTest userTest : userTests) {

            System.out.println(userTest.getIndex() + "-----" + userTest.toString());
        }


    }

    private List<UserTest> removeRepeatFactor(List<UserTest> list1, List<UserTest> list2) {
        if (list1 != null && list2 != null) {
            if (list1.size() != 0 && list2.size() != 0) {
                Collection<UserTest> A = new ArrayList<>(list1);
                List<UserTest> B = new ArrayList<>(list2);
                A.retainAll(B);
                if (A.size() != 0) {
                    B.removeAll(A);
                }
                return B;
            }
        }
        return list2;
    }

    private <T> List<T> removeRepeatFactor3(List<T> list1, List<T> list2) {
        if (list1 != null && list2 != null) {
            if (list1.size() != 0 && list2.size() != 0) {
                Collection<T> A = new ArrayList<>(list1);
                List<T> B = new ArrayList<>(list2);
                A.retainAll(B);
                if (A.size() != 0) {
                    B.removeAll(A);
                }
                return B;
            }
        }
        return list2;
    }

    public List<String> removeRepeatFactor2(List<String> list1, List<String> list2) throws Exception {
        if (list1 != null && list2 != null) {
            if (list1.size() != 0 && list2.size() != 0) {
                Collection<String> A = new ArrayList<>(list1);
                Collection<String> B = new ArrayList<>(list2);
                A.retainAll(B);
                if (A.size() != 0) {
                    B.removeAll(A);
                }
                return (List<String>) B;
            }
        }
        return list2;
    }


    @Test
    void t10() {

        QuestionsImportRequest questionsImportRequest = new QuestionsImportRequest();
        questionsImportRequest.setOptionA("aaa");
        questionsImportRequest.setOptionB("bbb");
        questionsImportRequest.setOptionC("ccc");
        questionsImportRequest.setOptionD("ddd");
        questionsImportRequest.setOptionE("eee");
        questionsImportRequest.setOptionF("fff");
        questionsImportRequest.setQuestionStem("stem");
        questionsImportRequest.setQuestionTypeName("type");

        System.out.println(questionsImportRequest.toStringForCompare());

    }

    @Test
    void t11() {

        List<UserTest> list = new ArrayList<>();
        list.add(new UserTest(1, "张三", "男", "深圳", "123456"));
        list.add(new UserTest(2, "李四", "男", "深圳", "123456"));
        list.add(new UserTest(3, "张三", "男", "杭州", "123456"));
        list.add(new UserTest(4, "张三", "男", "深圳", "123456"));
        list.add(new UserTest(5, "王五", "男", "深圳", "123456"));
        list.add(new UserTest(6, "张三", "男", "深圳", "123456"));
        list.add(new UserTest(7, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(8, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(9, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(10, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(11, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(12, "张三", "男", "菲律宾", "123456"));
        list.add(new UserTest(13, "张三", "男", "深圳", "123456"));
        list.add(new UserTest(14, "张三", "男", "马来西亚", "123456"));

        stringRedisTemplate.opsForList().leftPush("sss", list.toString());
    }

    @Test
    void t12() {
//        System.out.println(((float) 3 / (float) 10) * 100 + "%");

        int diliverNum = 3;//举例子的变量
        int queryMailNum = 10;//举例子的变量
// 创建一个数值格式化对象
        NumberFormat numberFormat = NumberFormat.getInstance();
// 设置精确到小数点后2位
        numberFormat.setMaximumFractionDigits(2);
        String result = numberFormat.format((float) diliverNum / (float) queryMailNum * 100);
        System.out.println("diliverNum和queryMailNum的百分比为:" + result + "%");
    }


    public String getPercent(int x, int total) {
        String result = "";//接受百分比的值
        double x_double = x * 1.0;
        double tempresult = x / total;
        //NumberFormat nf   =   NumberFormat.getPercentInstance();     注释掉的也是一种方法
        //nf.setMinimumFractionDigits( 2 );        保留到小数点后几位
        DecimalFormat df1 = new DecimalFormat("0.00%");    //##.00%   百分比格式，后面不足2位的用0补齐
        //result=nf.format(tempresult);
        result = df1.format(tempresult);
        return result;
    }


    @Test
    public void test100() {

        List<UserTest> list = new ArrayList<>();
        list.add(new UserTest(1, "张三", "男", "深圳", "123456"));
        list.add(new UserTest(2, "李四", "男", "深圳", "123456"));
        list.add(new UserTest(3, "张三", "男", "杭州", "123456"));
        list.add(new UserTest(4, "张三", "男", "深圳", "123456"));
        list.add(new UserTest(5, "王五", "男", "深圳", "123456"));
        list.add(new UserTest(6, "张三", "男", "深圳", "123456"));
        list.add(new UserTest(7, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(8, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(9, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(10, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(11, "赵六", "女", "深圳", "123456"));
        list.add(new UserTest(12, "张三", "男", "菲律宾", "123456"));
        list.add(new UserTest(13, "张三", "男", "深圳", "123456"));
        list.add(new UserTest(14, "张三", "男", "马来西亚", "123456"));

        Page<UserTest> page = new Page<>(1, 10);

//        page.setTotal(list.size());
//        page.setRecords(list);

        IPage<UserTest> convert = page.convert(new Function<Object, UserTest>() {
            @Override
            public UserTest apply(Object o) {

                return new UserTest(1, "张三", "男", "深圳", "123456");
            }
        });

        System.out.println(convert);


    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    class T {
        boolean b;
        String s;
    }

    @Test
    public void t101() {
        String[] s = new String[]{"5", "-2", "4", "C", "D", "9", "+", "+"};

        List<T> list = new ArrayList<>();

        for (int i = 0; i < s.length; i++) {

            list.add(new T(true, s[i]));

            if (s[i].equalsIgnoreCase("c")) {

            }
        }

        System.out.println();
    }

}
