package com.msdw.tms.service;

import com.msdw.tms.common.utils.FilesResult;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItem;
import org.apache.commons.io.IOUtils;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.mock.web.MockHttpServletResponse;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.commons.CommonsMultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.file.Files;

@SpringBootTest
class AliyunOssServiceTest {

    @Autowired
    AliyunOssService aliyunOssService;

    /**
     * 测试上传文件
     */
    @Test
    void testUploadFiles() throws IOException {
        File file = new File("D:\\pic\\1.jpg");
        FileItem fileItem = new DiskFileItem("file",
                Files.probeContentType(file.toPath()),
                false,
                file.getName(),
                (int) file.length(),
                file.getParentFile());
        IOUtils.copy(new FileInputStream(file), fileItem.getOutputStream());
        MultipartFile multipartFile = new CommonsMultipartFile(fileItem);
        FilesResult filesResult = aliyunOssService.uploadFiles(multipartFile);
        System.out.println(filesResult.toString());
    }

    /**
     * 测试下载文件
     */
    @Test
    void testDownloadFiles() throws IOException {
        HttpServletResponse response = new MockHttpServletResponse();
        AliyunOssService aliyunOssService = this.aliyunOssService;
        aliyunOssService.downloadFiles(response,
                "http://liuwanr.oss-cn-shenzhen.aliyuncs.com/jpg/20200807/1596787474773.jpg");
    }

    /**
     * 测试根据文件路径+文件名称，删除该文件
     */
    @Test
    void testDeleteFile() {
        aliyunOssService.deleteFile("http://liuwanr.oss-cn-shenzhen.aliyuncs.com/jpg/20200807/1596787474773.jpg");
    }
}
